/**
 * Test form (version 0.9.4)
 */

$(function() {
		generateForm();
});

function generateForm() {

	var section, count, code, xmlDoc, xml, questionSet, serializer;

	code = b64_to_utf8( $('#test-form-data').text().replace(/\s/g, "") );

	serializer = new XMLSerializer(),
	xmlDoc = $.parseXML( code ),
  xml = $( xmlDoc ),
  questionSet = new Array();

  /**
	 * sekce, ze ktere se otazky budou nacitat (cislo nebo vice cisel oddelenych carkami)
	 */
	if ( $('#test-form').data('section') ) {
		section = $.map($('#test-form').data('section').toString().split(','), $.trim);
	}

	if (section) {
		// vytazeni otazek z konkretni sekce
		$(xml).find('pack').each(function() {
			if ( $.inArray($(this).children('section').text(), section) > -1 ) {
				questionSet.push( $(this) );
			}
		});
	}
	else {
		// vsechny otazky
		$(xml).find('pack').each(function() {
				questionSet.push( $(this) );
		});
		count = 20;
	}
	
	/**
	 * pocet otazek, ktery se bude nacitat, default 3
	 */
	if ( $('#test-form').data('count') ) {
		count = $('#test-form').data('count');
	}
	if (!count) {
		count = 3;
	}

	// zrandomizování otázek
	questionSet.sort( function() { return 0.5 - Math.random() } );

	// pokud neni dostatecny pocet otazek v setu
	if ( questionSet.length < count ) {
		count = questionSet.length;
	}

	// nacist text k linku pro nespravne zodpovezenou otazku
	incorrect_text = $(xml).find('incorrect_text');
	if ( incorrect_text.length ) {
		incorrect_text = incorrect_text.text();
	}
	else {
		incorrect_text = "Chceš vědět víc?";
	}

	$('#test-form').empty();

	// cyklus pres vsechny otazky
	for (var i = 0; i < count; i++) {
		var el = '\
			<fieldset data-correct="' + questionSet[i].children('correct').text() + '">\
				<legend>' + questionSet[i].children('question').text() + '</legend>';
		var j = 1;
		// cyklus pres vsechny odpovedi
		while ( questionSet[i].children('answer' + j).length ) {
			el += '\
				<div>\
					<input type="radio" name="set-' + (i+1) + '" id="answer-' + (i+1) + '-' + j +'" value="' + j + '">\
					<label for="answer-' + (i+1) + '-' + j + '">' + $( serializer.serializeToString( questionSet[i].children('answer' + j)[0] ) ).html() + '</label>\
				</div>';
			j++;
		}
		if ( questionSet[i].children('incorrect_link').length ) {
			el += '<a href="' + questionSet[i].children('incorrect_link').text() + '" class="anchor-highlight incorrect_link" style="display: none;">' + incorrect_text + '</a>';
		}
		$('#test-form').append( $(el) );
	}

	var el = '\
			</fieldset>\
			<input type="submit" value="Vyhodnotit" id="submit">';
	$('#test-form').append( $(el) );

}

function utf8_to_b64( str ) {
  return window.btoa(unescape(encodeURIComponent( str )));
}

function b64_to_utf8( str ) {
  return decodeURIComponent(escape(window.atob( str )));
}

//kontrola formuláře pro nezaškrtnutí všech otázek
function checkForm(){
    var blank = false;
    $("#test-form input:radio").each(function() {
        var val = $('input:radio[name=' + this.name + ']:checked').val();
        if (val === undefined) {
            blank = true;
            return false;
        }
    });

    if(blank) {
        if (confirm("Nejsou vyplněny všechny otázky. Chcete přesto vyplňování ukončit a test předčasně vyhodnotit?")) {
        	evaluateForm();
        	return true;
        }
        else { return false; }          
    }

    else { 
    	evaluateForm();
    	return true;
    }   
}

// vyhodnocení formuláře
function evaluateForm() {

	var points = 0, pointsTotal = 0;

	$('#test-form').children('fieldset').each(function() {
		var correct = $(this).data('correct');
		$(this).find('input').each(function() {
			if ( $(this).attr('checked') && $(this).val() == correct ) {
				$(this).next().addClass('correct');
				points++;
			}
			else if ( $(this).attr('checked') ) {
				$(this).next().addClass('incorrect');
				$(this).closest('fieldset').find('.incorrect_link').removeAttr('style');
			}
			else if ( $(this).val() == correct ) {
				$(this).next().addClass('correct');
			}
		});
		pointsTotal++;
	});

	var el = '<p>Získané body: <strong>' + points + ' z ' + pointsTotal + '</strong> (' + Math.round(points*100/pointsTotal) + '% úspěšnost)</p>\n\
	<input type="reset" value="Vymazat kvíz" onclick="resetForm()">';
	$('#test-form').append( $(el) );
	$('#submit').hide();

}

function resetForm() {
	generateForm();
}